//Cg[VOCNX
import java.io.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;

public class RayTraceMain extends PaintFrame{
	static final int DEFAULT_WSIZE = 256;		//ftHg`̈TCY

	private FileReader inputfile = null;
	
	Color backColor;							//wiF
	PointLight pLight;							//_
	
	Vector materials;							//}eAXg
	Vector shapes;								//̃Xg
	
	//`
	public void paintScreen()
	{
		int xp,yp;
		Color col;
		int halfScreenWidth = getScreenWidth() / 2;
		int halfScreenHeight = getScreenHeight() / 2;
		long prevT;
		
		ViewPointRotate Z = new ViewPointRotate(/*Math.PI/4,Math.PI/4*/0,0);//
/*		Matrix Z = new Matrix(); //ϊs
		Z.m11 = Math.cos(Math.PI/4);	Z.m12 = 0;	Z.m13 = 0;
		Z.m21 = 0;			Z.m22 = 1;	Z.m23 = 0;
		Z.m31 = 0;			Z.m32 = 0;	Z.m33 = Math.sin(Math.PI/4);
*/
/*
		//_ʒuxNg
		Vector3D E = new Vector3D(700, 0, 700);
		E = Matrix.tVectorMatrix(E, Z);	//_ϊxNgs	
*/
		
		//`Jnۑ
		prevT = System.currentTimeMillis();
	
		//ubN̑傫w
		int xb = 16;
		int yb = xb;

		for(int yh = 0; yh < getScreenHeight()/yb; yh++){
		for(int xw = 0; xw < getScreenWidth()/xb; xw++){
		
		int yps = yh*yb; int ype = (yh+1)*yb /*-1*/;
		int xps = xw*xb; int xpe = (xw+1)*xb /*-1*/;
		
		for(yp = yps; yp < ype; yp++)
		{
			for(xp = xps; xp < xpe; xp++)
			{
				//_ʒuxNg
				Vector3D E = new Vector3D(0, 0, 700);
				//E = Matrix.tVectorMatrix(E, Z);	//_ϊxNgs	
				E = Z.RunRotate(E);

/*				int hitObject = -1;
				double t = 0;
				double minT = Double.MAX_VALUE;
				BaseShape minTShape = null;
*/			
				//xNgvZ
				Vector3D V = new Vector3D(xp - halfScreenWidth,
				                          -yp + halfScreenHeight, /*(-xp + halfScreenWidth)*/0);
				//V = Matrix.tVectorMatrix(V, Z);//ϊxNgs
				V = Z.RunRotate(V);

				V = Vector3D.normalize(Vector3D.sub(V, E));
				
				double energy = 1.0;
				int hitNumber = 0;
				setPixel(xp, yp, backColor);

				while(energy > 0){
					int hitObject = -1;
					double t = 0;
					double minT = Double.MAX_VALUE;
					BaseShape minTShape = null;
					
					//
					for (int i = 0; i < shapes.size(); i++)
					{
						//̃Xgo
						BaseShape tmpShape = (BaseShape)shapes.get(i);
					
						//
						t = tmpShape.calcT(E, V);
					
						//̂ƏՓ˂Ă
						if ((t >= 0) && (t < minT))
						{
							//ł߂̏XV
							minT = t;
							hitObject = i;
							minTShape = tmpShape;
						}
					}
				
					//Փ˂݂̂ꍇVF[fBOvZ
					if (hitObject >= 0)
					{
						//_vZ
						Vector3D hitPos = Vector3D.add(Vector3D.scale(minT, V), E);
				
						Material usingMaterial = (Material)materials.get(minTShape.getUsingMaterialIndex());
						Color pcol = minTShape.calcShading(pLight, hitPos, E, usingMaterial);
						setPixel(xp, yp, pcol);
					
						hitNumber++;

						Vector3D N = minTShape.calcNorm(hitPos);
						V=Vector3D.normalize(Vector3D.add(Vector3D.scale((-2.0*Vector3D.dotProduct(N,V)),N),V));
						E=hitPos;
						energy -= usingMaterial.getKa();
					}
					else{
						energy=0.0;
						//setPixel(xp, yp, backColor);
					}
				}
			}
		}

		}}

		//`掞ԕ\
		System.out.println(Long.toString(System.currentTimeMillis() - prevT) + "[ms]");
	}
	
	//main
	public static void main(String[] args){   
		RayTraceMain paintwindow;
		
		if (args.length > 1)	//EChETCYw肳Ăꍇ
		{
			try 
			{
				paintwindow = new RayTraceMain(args[0], Integer.parseInt(args[1]));	
				
				paintwindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);//I̐ݒ
		
				paintwindow.paintScreen();		//`
			}
			catch(IllegalArgumentException e)
			{
				System.out.println("EChETCY𐮐Ŏw肵Ă");
				System.exit(0);
			}
		}
		else if (args.length > 0)	//EChETCYw肳ĂȂꍇftHgTCYŃEChE
		{
			paintwindow = new RayTraceMain(args[0], DEFAULT_WSIZE);
			
			paintwindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);//I̐ݒ
		
			paintwindow.paintScreen();		//`	
		}
		else
		{
			System.out.println("ǂݍރt@Cw肵Ă");
			System.exit(0);
		}
    }
	
	//w肳ꂽf[^t@CifileNamejǂݍ
	public void readSceneFile(String fileName)
	{
		try{
			inputfile=new FileReader(fileName);
		
			BufferedReader in=new BufferedReader(inputfile);
		
			//_f[^Ǎ
			pLight = new PointLight(in.readLine());
		
			//wiFf[^Ǎ
			backColor = inputColor(in.readLine());
		
			//}eAǍ
			int numMaterial = Integer.parseInt(in.readLine());
		
			//}eAǍ
			for (int i = 0; i < numMaterial; i++)
				materials.add(new Material(in.readLine()));
			
			//EllipseǍ
			int numEllipse = Integer.parseInt(in.readLine());
		
			//EllipseǍ
			for (int i = 0; i < numEllipse; i++)
				shapes.add(new Ellipse(in.readLine()));
			
		}
		catch(FileNotFoundException e)
		{
			System.out.println("w肳ꂽt@C["+fileName+"]܂");
			System.exit(0);
		}
		catch(IOException e)
		{
			System.out.println(e);
			System.exit(0);	
		}
		catch(IllegalArgumentException e)
		{
			System.out.println(e);
			System.exit(0);			
		}
		catch(OutOfMemoryError e)
		{
			System.out.println(e);
			System.exit(0);
		}
	}
	
	//RXgN^
	public RayTraceMain(String dataFile, int windowSize)
	{
		super(windowSize, windowSize);
		
		materials = new Vector();
		shapes = new Vector();
		
		readSceneFile(dataFile);
	}

    //F𕶎ǂݍ 
	public Color inputColor(String data){
		int r=0;
		int g=0;
		int b=0;

		try
		{
			String str=data;
			StringTokenizer s=new StringTokenizer(str," ");	//Xy[XƂɕ񕪊
			if (s.countTokens() >= 3)
			{						//͂ꂽ3ȏȂǂݍ
				r = Integer.parseInt(s.nextToken()) & 255;	//255ȏ̒l͂h~
				g = Integer.parseInt(s.nextToken()) & 255;
				b = Integer.parseInt(s.nextToken()) & 255;
			}
			else
			{
				throw new IllegalArgumentException("[raytracemain]͒ľ܂:" + str);
			}
		}
		catch(IllegalArgumentException e)
		{
			throw e;
		}

		return(new Color(r,g,b));
	}
}
